#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

#include "xoshiro256starstar.h"

uint64_t scalar128(const uint64_t x[2], const uint64_t y[2])
{
    uint64_t r[2];

    r[0] = x[0] & y[0];
    r[1] = x[1] & y[1];

    return (__builtin_popcountl(r[0]) + __builtin_popcountl(r[1])) & 1;
}

uint8_t lpn_sampler_100_8(const uint64_t s[2], uint64_t a[2])
{
    uint8_t r = 0;

        a[0] = xoshiro256starstar_random();
        a[1] = xoshiro256starstar_random() & 0xFFFFFFFFF;
        uint64_t e = (xoshiro256starstar_random() & 7) == 0 ? 1 : 0;
        r = scalar128(s, a) ^ e;

    return r;
}

struct bkw_table_e
{
    uint64_t a[2];
    uint8_t v;
};

struct bkw_table
{
    struct bkw_table_e **main_elems;
    struct bkw_table_e *red_elems;
    int64_t *main_elems_cnt;
    uint64_t block_size;
    uint64_t max_main;
};

struct short_bkw_table
{
    struct bkw_table_e *elems;
    int64_t elems_cnt;
};
